<template>
  <div div="user">
    <b-jumbotron>
      <template
        slot="header"
      >Criterion {{ $route.params.criterionName }}</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>

      <div>Criterion {{ criterion.name }}</div>
      <div class="mydiv-tablealign">
      <table class="table table-bordered">

      <tr>
        <td>Name</td>
        <td>{{criterion.name}}</td>
      </tr>
      <tr>
        <td>Mark Mode</td>
        <td>{{criterion.markMode === 'None' ? '-' : criterion.markMode}}</td>
      </tr>
      <tr>
        <td>Mark Value</td>
        <td>{{criterion.markMode === 'None' ? '-' : criterion.mark}}</td>
      </tr>
      <tr>
        <td>Mark Matching</td>
        <td>{{criterion.markMode === 'None' ? '-' : criterion.markMatch}}</td>
      </tr>

      <tr>
        <td>Attempts Mode</td>
        <td>{{criterion.attemptsMode === 'None' ? '-' : criterion.attemptsMode}}</td>
      </tr>
      <tr>
        <td>Attempts Value</td>
        <td>{{criterion.attemptsMode === 'None' ? '-' : criterion.attempts}}</td>
      </tr>
      <tr>
        <td>Attempts Matching</td>
        <td>{{criterion.attemptsMode === 'None' ? '-' : criterion.attemptsMatch}}</td>
      </tr>
      <tr>
        <td>Exams</td>
        <td>{{criterion.requireExams ? 'Required' : 'Not required'}}</td>
      </tr>
      </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  name: "Criterion",
  data() {
    return {
      criterion: { name: "??"},
      alertMessage: "Request error",
      hasError: false
    };
  },
  mounted() {
    this.loadItems(
      this.$route.params.criterionName
    );
  },
  beforeRouteUpdate(to, _, next) {
    this.loadItems(to.params.criterionName);
    next();
  },
  methods: {
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    async loadItems(criterionName) {
      let res = await AXIOS.get("/edu/criterion/" + criterionName, {})
        .then(
          response => {
            console.log(response);
            this.criterion = response.data;
            return this.criterion;
          },
          error => {
            this.$data.alertMessage = error.response.data;
            this.hasError = true;
            this.criterion = { name: "??"};
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.criterion = { name: "??"};
          this.hasError = true;
        });
      console.log(res);
    }
  }
};
</script>

<style>
.mydiv-tablealign{
	text-align:center
}
</style>